<template>
    <v-row>
        <v-col>
            <v-tabs
                fixed-tabs
                background-color="indigo darken-2"
                dark
            >
                <v-tab class="font-weight-bold" :to="'/product/edit/' + this.id" >
                    <v-icon>mdi-store</v-icon>
                </v-tab>

                <v-tab class="font-weight-bold" :to="'/product/stock/' + this.id" >
                    {{ $tc('stock', 2) }}
                </v-tab>
            </v-tabs>

            <v-card>
                <v-card-title>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" @click="openDialog()">
                        <v-icon left>mdi-plus</v-icon>
                        <span>{{ $t('create') }}</span>
                    </v-btn>
                </v-card-title>

                <v-container>
                    <v-data-table
                        flat
                        :headers="headers"
                        :loading="loading"
                        :items="stocks"
                        :items-per-page="5"
                        :single-expand="singleExpand"
                        :expanded.sync="expanded"
                        item-key="id"
                        show-expand
                    >
                        <template v-slot:item.combination="{ item }">
                            {{ item.option_combination || 'N/A' }}
                        </template>

                        <template v-slot:item.state="{ item }">
                            <td>
                                <v-chip
                                    :color="item.enabled ? 'success' : 'error'"
                                    text-color="white"
                                    label
                                >
                                    {{ item.enabled ? $t('enabled') : $t('disabled') }}
                                </v-chip>
                            </td>
                        </template>

                        <template v-slot:item.action="{ item }">
                            <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>

                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                @click="openDialog(item)"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-divider class="my-2"></v-divider>
                                        <v-list-item>
                                            <v-btn
                                                @click="openDeleteDialog(item)"
                                                class="text-capitalize"
                                                color="error"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-delete</v-icon>
                                                {{ $t('delete') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>

                        </template>
                        <template v-slot:expanded-item="{ headers, item }">
                            <template>
                                <td :colspan="headers.length">
                                    <v-product-tag-table
                                        :stock_id ="item.id"
                                    >
                                    </v-product-tag-table>
                                </td>
                            </template>

                        </template>
                    </v-data-table>

                    <v-dialog v-if="stock" v-model="dialog" persistent max-width="600px">
                        <v-card>
                            <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                <v-card-title>
                                    <span class="headline">
                                        {{ $t('product_', [$tc('stock', 1)]) }}
                                    </span>

                                    <v-spacer></v-spacer>

                                    <v-switch
                                        v-model="stock.enabled"
                                        inset
                                        :label="$t('enabled')"
                                        :true-value="1"
                                        :false-value="0"
                                    >
                                    </v-switch>
                                </v-card-title>

                                <v-card-text>
                                    <v-container>
                                        <v-row>
                                            <v-col>
                                                <div class="field-label">{{ $t('vendor') }}</div>
                                                <ValidationProvider v-slot="{ errors }" name="vendor" rules="required">
                                                    <vendor-select
                                                            v-model="stock.vendor_id"
                                                            :errors="errors"
                                                    >
                                                    </vendor-select>
                                                </ValidationProvider>
                                            </v-col>
                                        </v-row>

                                        <v-row>
                                            <v-col>
                                                <div class="field-label">{{ $t('combination') }}</div>
                                                <ValidationProvider v-slot="{ errors }" name="combination" rules="required">
                                                    <v-select
                                                        v-model="stock.product_variant_option_ids"
                                                        :error-messages="errors"
                                                        item-text="name"
                                                        item-value="ids"
                                                        :items="combinations"
                                                        outlined
                                                        :disabled = "isEditMode"
                                                    >
                                                    </v-select>
                                                </ValidationProvider>
                                            </v-col>
                                        </v-row>

                                        <v-row>
                                            <v-col>
                                                <div class="field-label">{{ $t('price') }}</div>
                                                    <ValidationProvider v-slot="{ errors }" name="price" rules="required">
                                                        <v-text-field
                                                            v-model="stock.price"
                                                            :error-messages="errors"
                                                            outlined
                                                        >
                                                        </v-text-field>
                                                    </ValidationProvider>
                                            </v-col>
                                             <v-col>
                                                <div class="field-label">{{ $t('cost_price') }}</div>
                                                 <ValidationProvider v-slot="{ errors }" name="cost price" rules="required">
                                                     <v-text-field
                                                        v-model="stock.cost_price"
                                                        :error-messages="errors"
                                                        outlined
                                                    >
                                                    </v-text-field>
                                                 </ValidationProvider>
                                             </v-col>
                                        </v-row>
                                         <v-row>
                                            <v-col>
                                                <div class="field-label">{{ $t('sku') }}</div>
                                                    <ValidationProvider v-slot="{ errors }" name="SKU" rules="required">
                                                        <v-text-field
                                                            v-model="stock.sku"
                                                            :error-messages="errors"
                                                            outlined
                                                            :disabled = "isEditMode"
                                                        >
                                                        </v-text-field>
                                                    </ValidationProvider>
                                            </v-col>
                                        </v-row>

                                    </v-container>
                                </v-card-text>

                                <v-card-actions class="py-5 justify-center">
                                    <v-btn color="primary"
                                           :loading="loading"
                                           @click="closeDialog"
                                    >
                                        <v-icon left>mdi-close</v-icon>
                                        {{ $t('close') }}
                                    </v-btn>

                                    <v-btn color="primary"
                                           :loading="loading"
                                           @click="action"
                                    >
                                        <v-icon left>mdi-content-save</v-icon>
                                        {{ $t('save') }}
                                    </v-btn>
                                </v-card-actions>
                            </ValidationObserver>
                        </v-card>
                    </v-dialog>
                </v-container>
            </v-card>

            <v-dialog
                v-model="deleteDialog"
                persistent
                max-width="300"
            >
                <v-card>
                    <v-card-title class="headline primary white--text">
                        {{ $t('delete_', [$t('product')]) }}
                    </v-card-title>

                    <v-card-text class="pt-2">
                        <p class="pt-2 mb-2">{{ $t('del_desc_1') }}</p>
                        <p>{{ $t('del_desc_2') }}</p>
                    </v-card-text>

                    <v-card-actions class="justify-center">
                        <v-btn
                            color="primary"
                            text
                            :loading="loading"
                            @click="closeDeleteDialog"
                        >
                            {{ $t('no') }}
                        </v-btn>

                        <v-btn
                            color="primary"
                            text
                            :loading="loading"
                            @click="deleteStock"
                        >
                            {{ $t('yes') }}
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-col>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import VWarehouseSelect from "../VWarehouseSelect";
    import VendorSelect from "../VendorSelect";
    import VProductTagTable from "../VProductTagTable";
    import { mapMutations } from "vuex";

    export default {
        name: "ProductStockForm",
        components: {
            VWarehouseSelect,
            ValidationObserver,
            VendorSelect,
            ValidationProvider,
            VProductTagTable
        },

        props: {
            id: [String, Number],
        },

        data: () => ({
            loading: true,
            dialog: false,
            deleteDialog: false,
            stock: null,
            deleting: null,
            combinations: [],
            stocks: [],
            expanded: [],
            singleExpand: false,
            warehouse:'',
            vendor_id: '',
            tags:[],
            active: true,
            isEditMode : false
        }),

        computed: {
            headers() {
                return [
                    {
                        text: this.$t('combination'),
                        align: 'start',
                        sortable: false,
                        value: 'combination',
                    },
                    {
                        text: this.$t('sku'),
                        sortable: false,
                        value: 'sku'
                    },
                    {
                        text: this.$t('price'),
                        value: 'price'
                    },
                    {
                        text: this.$t('cost_price'),
                        value: 'cost_price'
                    },
                    {
                        text: this.$t('reserved'),
                        value: 'reserved'
                    },
                    {
                        text: this.$t('state'),
                        value: 'state'
                    },
                    {
                        text: this.$t('action'),
                        value: 'action'
                    }
                ]
            }
        },

        mounted() {
            this.fetchStocks()
                .then(data => {
                    this.stocks = data;
                    this.loading = false;
                });

            this.fetchCombinations()
                .then(data => {
                    this.combinations = data;
                });
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchStocks() {
                return new Promise((resolve, reject) => {
                    axios.get(`api/products/stocks/${this.id}`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        });
                })
            },

            fetchCombinations() {
                return new Promise((resolve, reject) => {
                    axios.get(`api/products/combinations/${this.id}`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            async action() {
                const isValid = await this.$refs.observer.validate();
                if (!isValid) {
                    return;
                }

                if(this.stock) {
                    if(this.stock.hasOwnProperty('id')) {
                        this.updateStock();
                    }
                    else {
                        this.createStock();
                    }
                }
            },

            createStock() {
                this.loading = true;
                console.log(this.stock)
                axios.post(`api/products/stocks/${this.id}`, this.stock)
                    .then(({ data }) => {
                        this.loading = false;
                        this.stocks.push(data);
                        this.closeDialog();
                    })
                    .catch(error => {
                        this.loading = false;
                    })
            },

            updateStock() {
                this.loading = true;

                axios.put(`api/products/stocks/${this.stock.id}`, this.stock)
                    .then(({ data }) => {
                        let index = this.stocks.findIndex(s => s.id === this.stock.id);
                        this.$set(this.stocks, index, data);
                        this.closeDialog();
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            deleteStock() {
                this.loading = true;

                const payload = {
                    data: {
                        ids: [this.deleting.id]
                    }
                };

                axios.delete(`api/products/stocks/${this.id}`, payload)
                    .then(({ data }) => {
                        const index = this.stocks.findIndex(stock => stock.id === this.deleting.id);
                        this.stocks.splice(index, 1);
                        this.loading = false;
                        this.closeDeleteDialog();
                    })
                    .catch(error => {
                        this.loading = false;
                    })
            },

            openDialog(item) {
                this.isEditMode = true
                if(!item) {
                    this.isEditMode = false
                    item = {
                        enabled: 1,
                        sku: '',
                        price: 0,
                        cost_price: 0,
                        product_variant_option_ids: []
                    };
                }
                this.stock = item;
                this.stock.enabled = this.stock.enabled ? 1 : 0;
                this.dialog = true;

            },

            closeDialog() {
                this.stock = null;
                this.dialog = false;
            },

            openDeleteDialog(item) {
                this.deleting = item;
                this.deleteDialog = true;
            },

            closeDeleteDialog() {
                this.deleting = null;
                this.deleteDialog = false;
            },
        }
    }
</script>

<style>
    .toggle.v-input--selection-controls {
        margin-top: 0 !important;
    }

</style>
